Improve VLA wording in NEWS
[autoconf.git] / maint.mk
blobc30e71ba6ec7223d61de422fc3013a8acf3a9e52
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
5 ## Copyright (C) 2001-2024 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <https://www.gnu.org/licenses/>.
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
24 # These variables ought to be defined through the configure.ac section
25 # of the module description. But some packages import this file directly,
26 # ignoring the module description.
27 AWK ?= awk
28 GREP ?= grep
29 SED ?= sed
31 # Helper variables.
32 _empty =
33 _sp = $(_empty) $(_empty)
35 # _equal,S1,S2
36 # ------------
37 # If S1 == S2, return S1, otherwise the empty string.
38 _equal = $(and $(findstring $(1),$(2)),$(findstring $(2),$(1)))
40 # member-check,VARIABLE,VALID-VALUES
41 # ----------------------------------
42 # Check that $(VARIABLE) is in the space-separated list of VALID-VALUES, and
43 # return it. Die otherwise.
44 member-check = \
45 $(strip \
46 $(if $($(1)), \
47 $(if $(findstring $(_sp),$($(1))), \
48 $(error invalid $(1): '$($(1))', expected $(2)), \
49 $(or $(findstring $(_sp)$($(1))$(_sp),$(_sp)$(2)$(_sp)), \
50 $(error invalid $(1): '$($(1))', expected $(2)))), \
51 $(error $(1) undefined)))
53 # Do not save the original name or timestamp in the .tar.gz file.
54 # Use --rsyncable if available.
55 gzip_rsyncable := \
56 $(shell gzip --help 2>/dev/null|$(GREP) rsyncable >/dev/null \
57 && printf %s --rsyncable)
58 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
60 GIT = git
61 VC = $(GIT)
63 VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
65 # You can override this variable in cfg.mk if your gnulib submodule lives
66 # in a different location.
67 gnulib_dir ?= $(shell if test -n "$(GNULIB_SRCDIR)" && test -f "$(GNULIB_SRCDIR)/gnulib-tool"; then \
68 echo "$(GNULIB_SRCDIR)"; \
69 else \
70 echo $(srcdir)/gnulib; \
71 fi)
73 # You can override this variable in cfg.mk to set your own regexp
74 # matching files to ignore.
75 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
77 # This is to preprocess robustly the output of $(VC_LIST), so that even
78 # when $(srcdir) is a pathological name like "....", the leading sed command
79 # removes only the intended prefix.
80 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
82 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
83 # when $(srcdir) is not ".".
84 ifeq ($(srcdir),.)
85 _prepend_srcdir_prefix =
86 else
87 _prepend_srcdir_prefix = | $(SED) 's|^|$(srcdir)/|'
88 endif
90 # In order to be able to consistently filter "."-relative names,
91 # (i.e., with no $(srcdir) prefix), this definition is careful to
92 # remove any $(srcdir) prefix, and to restore what it removes.
93 _sc_excl = \
94 $(or $(exclude_file_name_regexp--$@),^$$)
95 VC_LIST_EXCEPT = \
96 $(VC_LIST) | $(SED) 's|^$(_dot_escaped_srcdir)/||' \
97 | if test -f $(srcdir)/.x-$@; then $(GREP) -vEf $(srcdir)/.x-$@; \
98 else $(GREP) -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
99 | $(GREP) -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
100 $(_prepend_srcdir_prefix)
102 ifeq ($(origin prev_version_file), undefined)
103 prev_version_file = $(srcdir)/.prev-version
104 endif
106 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
107 VERSION_REGEXP = $(subst .,\.,$(VERSION))
108 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
110 ifeq ($(VC),$(GIT))
111 this-vc-tag = v$(VERSION)
112 this-vc-tag-regexp = v$(VERSION_REGEXP)
113 else
114 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
115 tag-this-version = $(subst .,_,$(VERSION))
116 this-vc-tag = $(tag-package)-$(tag-this-version)
117 this-vc-tag-regexp = $(this-vc-tag)
118 endif
119 my_distdir = $(PACKAGE)-$(VERSION)
121 # Old releases are stored here.
122 release_archive_dir ?= ../release
124 # If RELEASE_TYPE is undefined, but RELEASE is, use its second word.
125 # But overwrite VERSION.
126 ifdef RELEASE
127 VERSION := $(word 1, $(RELEASE))
128 RELEASE_TYPE ?= $(word 2, $(RELEASE))
129 endif
131 # Validate and return $(RELEASE_TYPE), or die.
132 RELEASE_TYPES = alpha beta stable
133 release-type = $(call member-check,RELEASE_TYPE,$(RELEASE_TYPES))
135 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
136 # Use alpha.gnu.org for alpha and beta releases.
137 # Use ftp.gnu.org for stable releases.
138 gnu_ftp_host-alpha = alpha.gnu.org
139 gnu_ftp_host-beta = alpha.gnu.org
140 gnu_ftp_host-stable = ftp.gnu.org
141 gnu_rel_host ?= $(gnu_ftp_host-$(release-type))
143 url_dir_list ?= $(if $(call _equal,$(gnu_rel_host),ftp.gnu.org), \
144 https://ftpmirror.gnu.org/$(PACKAGE), \
145 https://$(gnu_rel_host)/gnu/$(PACKAGE))
147 # Override this in cfg.mk if you are using a different format in your
148 # NEWS file.
149 today = $(shell date +%Y-%m-%d)
151 # Select which lines of NEWS are searched for $(news-check-regexp).
152 # This is a sed line number spec. The default says that we search
153 # lines 1..10 of NEWS for $(news-check-regexp).
154 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
155 news-check-lines-spec ?= 1,10
156 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
158 # Prevent programs like 'sort' from considering distinct strings to be equal.
159 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
160 export LC_ALL = C
162 ## --------------- ##
163 ## Sanity checks. ##
164 ## --------------- ##
166 ifneq ($(_gl-Makefile),)
167 _cfg_mk := $(wildcard $(srcdir)/cfg.mk)
169 # Collect the names of rules starting with 'sc_'.
170 syntax-check-rules := $(sort $(shell env LC_ALL=C $(SED) -n \
171 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(srcdir)/$(ME) $(_cfg_mk)))
172 .PHONY: $(syntax-check-rules)
174 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
175 local-checks-available += $(syntax-check-rules)
176 else
177 local-checks-available += no-vc-detected
178 no-vc-detected:
179 @echo "No version control files detected; skipping syntax check"
180 endif
181 .PHONY: $(local-checks-available)
183 # Arrange to prine the name of each syntax-checking rule just before running it.
184 $(syntax-check-rules): %: %.m
185 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
186 .PHONY: $(sc_m_rules_)
187 $(sc_m_rules_):
188 @echo $(patsubst sc_%.m, %, $@)
189 @date +%s.%N > .sc-start-$(basename $@)
191 # Compute and print the elapsed time for each syntax-check rule.
192 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
193 .PHONY: $(sc_z_rules_)
194 $(sc_z_rules_): %.z: %
195 @end=$$(date +%s.%N); \
196 start=$$(cat .sc-start-$*); \
197 rm -f .sc-start-$*; \
198 $(AWK) -v s=$$start -v e=$$end \
199 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
201 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
202 # that computes and prints elapsed time.
203 local-check := \
204 $(patsubst sc_%, sc_%.z, \
205 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
207 syntax-check: $(local-check)
208 endif
210 # _sc_search_regexp
212 # This macro searches for a given construct in the selected files and
213 # then takes some action.
215 # Parameters (shell variables):
217 # prohibit | require
219 # Regular expression (ERE) denoting either a forbidden construct
220 # or a required construct. Those arguments are exclusive.
222 # exclude
224 # Regular expression (ERE) denoting lines to ignore that matched
225 # a prohibit construct. For example, this can be used to exclude
226 # comments that mention why the nearby code uses an alternative
227 # construct instead of the simpler prohibited construct.
229 # in_vc_files | in_files
231 # grep-E-style regexp selecting the files to check. For in_vc_files,
232 # the regexp is used to select matching files from the list of all
233 # version-controlled files; for in_files, it's from the names printed
234 # by "find $(srcdir)". When neither is specified, use all files that
235 # are under version control.
237 # containing | non_containing
239 # Select the files (non) containing strings matching this regexp.
240 # If both arguments are specified then CONTAINING takes
241 # precedence.
243 # with_grep_options
245 # Extra options for grep.
247 # ignore_case
249 # Ignore case.
251 # halt
253 # Message to display before to halting execution.
255 # Finally, you may exempt files based on an ERE matching file names.
256 # For example, to exempt from the sc_space_tab check all files with the
257 # .diff suffix, set this Make variable:
259 # exclude_file_name_regexp--sc_space_tab = \.diff$
261 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
262 # when filtering by name via in_files, we explicitly filter out matching
263 # names here as well.
265 # Initialize each, so that envvar settings cannot interfere.
266 export require =
267 export prohibit =
268 export exclude =
269 export in_vc_files =
270 export in_files =
271 export containing =
272 export non_containing =
273 export halt =
274 export with_grep_options =
276 # By default, _sc_search_regexp does not ignore case.
277 export ignore_case =
278 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
280 define _sc_say_and_exit
281 dummy=; : so we do not need a semicolon before each use; \
282 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
283 endef
285 define _sc_search_regexp
286 dummy=; : so we do not need a semicolon before each use; \
288 : Check arguments; \
289 test -n "$$prohibit" && test -n "$$require" \
290 && { msg='Cannot specify both prohibit and require' \
291 $(_sc_say_and_exit) } || :; \
292 test -z "$$prohibit" && test -z "$$require" \
293 && { msg='Should specify either prohibit or require' \
294 $(_sc_say_and_exit) } || :; \
295 test -z "$$prohibit" && test -n "$$exclude" \
296 && { msg='Use of exclude requires a prohibit pattern' \
297 $(_sc_say_and_exit) } || :; \
298 test -n "$$in_vc_files" && test -n "$$in_files" \
299 && { msg='Cannot specify both in_vc_files and in_files' \
300 $(_sc_say_and_exit) } || :; \
301 test "x$$halt" != x \
302 || { msg='halt not defined' $(_sc_say_and_exit) }; \
304 : Filter by file name; \
305 if test -n "$$in_files"; then \
306 files=$$(find $(srcdir) | $(GREP) -E "$$in_files" \
307 | $(GREP) -Ev '$(_sc_excl)'); \
308 else \
309 files=$$($(VC_LIST_EXCEPT)); \
310 if test -n "$$in_vc_files"; then \
311 files=$$(echo "$$files" | $(GREP) -E "$$in_vc_files"); \
312 fi; \
313 fi; \
315 : Filter by content; \
316 test -n "$$files" \
317 && test -n "$$containing" \
318 && { files=$$(echo "$$files" | xargs $(GREP) -l "$$containing"); } \
319 || :; \
320 test -n "$$files" \
321 && test -n "$$non_containing" \
322 && { files=$$(echo "$$files" | xargs $(GREP) -vl "$$non_containing"); } \
323 || :; \
325 : Check for the construct; \
326 if test -n "$$files"; then \
327 if test -n "$$prohibit"; then \
328 echo "$$files" \
329 | xargs $(GREP) $$with_grep_options $(_ignore_case) -nE \
330 "$$prohibit" /dev/null \
331 | $(GREP) -vE "$${exclude:-^$$}" \
332 && { msg="$$halt" $(_sc_say_and_exit) } \
333 || :; \
334 else \
335 echo "$$files" \
336 | xargs \
337 $(GREP) $$with_grep_options $(_ignore_case) -LE "$$require" \
338 | $(GREP) . \
339 && { msg="$$halt" $(_sc_say_and_exit) } \
340 || :; \
341 fi \
342 else :; \
343 fi || :;
344 endef
346 sc_avoid_if_before_free:
347 @$(VC_LIST_EXCEPT) \
348 | $(GREP) -v useless-if-before-free \
349 | xargs \
350 $(srcdir)/$(_build-aux)/useless-if-before-free \
351 $(useless_free_options) \
352 && { printf '$(ME): found useless "if"' \
353 ' before "free" above\n' 1>&2; \
354 exit 1; } \
355 || :
357 sc_cast_of_argument_to_free:
358 @prohibit='\<free *\( *\(' halt="don't cast free argument" \
359 $(_sc_search_regexp)
361 sc_cast_of_x_alloc_return_value:
362 @prohibit='\*\) *x(m|c|re)alloc\>' \
363 halt="don't cast x*alloc return value" \
364 $(_sc_search_regexp)
366 sc_cast_of_alloca_return_value:
367 @prohibit='\*\) *alloca\>' \
368 halt="don't cast alloca return value" \
369 $(_sc_search_regexp)
371 sc_space_tab:
372 @prohibit='[ ] ' \
373 halt='found SPACE-TAB sequence; remove the SPACE' \
374 $(_sc_search_regexp)
376 # Don't use *scanf or the old ato* functions in "real" code.
377 # They provide no error checking mechanism.
378 # Instead, use strto* functions.
379 sc_prohibit_atoi_atof:
380 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
381 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
382 $(_sc_search_regexp)
384 # Use STREQ rather than comparing strcmp == 0, or != 0.
385 sp_ = strcmp *\(.+\)
386 sc_prohibit_strcmp:
387 @prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)' \
388 exclude='# *define STRN?EQ\(' \
389 halt='replace strcmp calls above with STREQ/STRNEQ' \
390 $(_sc_search_regexp)
392 # Really. You don't want to use this function.
393 # It may fail to NUL-terminate the destination,
394 # and always NUL-pads out to the specified length.
395 sc_prohibit_strncpy:
396 @prohibit='\<strncpy *\(' \
397 halt='do not use strncpy, period' \
398 $(_sc_search_regexp)
400 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
401 # Convert all uses automatically, via these two commands:
402 # git grep -l '\<exit *(1)' \
403 # | grep -vEf .x-sc_prohibit_magic_number_exit \
404 # | xargs --no-run-if-empty \
405 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
406 # git grep -l '\<exit *(0)' \
407 # | grep -vEf .x-sc_prohibit_magic_number_exit \
408 # | xargs --no-run-if-empty \
409 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
410 sc_prohibit_magic_number_exit:
411 @prohibit='(^|[^.])\<(usage|exit|error) ?\(-?[0-9]+[,)]' \
412 exclude='exit \(77\)|error ?\(((0|77),|[^,]*)' \
413 halt='use EXIT_* values rather than magic number' \
414 $(_sc_search_regexp)
416 # Check that we don't use $< in non-implicit Makefile rules.
418 # To find the Makefiles, trace AC_CONFIG_FILES. Using VC_LIST would
419 # miss the Makefiles that are not under VC control (e.g., symlinks
420 # installed for gettext). "Parsing" (recursive) uses of SUBDIRS seems
421 # too delicate.
423 # Use GNU Make's --print-data-base to normalize the rules into some
424 # easy to parse format: they are separated by two \n. Look for the
425 # "section" about non-pattern rules (marked with "# Files") inside
426 # which there are still the POSIX Make like implicit rules (".c.o").
427 sc_prohibit_gnu_make_extensions_awk_ = \
428 BEGIN { \
429 RS = "\n\n"; \
430 in_rules = 0; \
432 /^\# Files/ { \
433 in_rules = 1; \
435 /\$$</ && in_rules && $$0 !~ /^(.*\n)*\.\w+(\.\w+)?:/ { \
436 print "Error: " file ": $$< in a non implicit rule\n" $$0; \
437 status = 1; \
439 END { \
440 exit status; \
442 sc_prohibit_gnu_make_extensions:
443 @if $(AWK) --version | grep GNU >/dev/null 2>&1; then \
444 (cd $(srcdir) && autoconf --trace AC_CONFIG_FILES:'$$1') | \
445 tr ' ' '\n' | \
446 $(SED) -ne '/Makefile/{s/\.in$$//;p;}' | \
447 while read m; do \
448 $(MAKE) -qp -f $$m .DUMMY-TARGET 2>/dev/null | \
449 $(AWK) -v file=$$m -e '$($@_awk_)' || exit 1; \
450 done; \
453 # Using EXIT_SUCCESS as the first argument to error is misleading,
454 # since when that parameter is 0, error does not exit. Use '0' instead.
455 sc_error_exit_success:
456 @prohibit='error *\(EXIT_SUCCESS,' \
457 in_vc_files='\.[chly]$$' \
458 halt='found error (EXIT_SUCCESS' \
459 $(_sc_search_regexp)
461 # "FATAL:" should be fully upper-cased in error messages
462 # "WARNING:" should be fully upper-cased, or fully lower-cased
463 sc_error_message_warn_fatal:
464 @$(VC_LIST_EXCEPT) \
465 | xargs $(GREP) -nEA2 '[^rp]error *\(' /dev/null \
466 | $(GREP) -E '"Warning|"Fatal|"fatal' \
467 && { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
468 exit 1; } \
469 || :
471 # Error messages should not start with a capital letter
472 sc_error_message_uppercase:
473 @$(VC_LIST_EXCEPT) \
474 | xargs $(GREP) -nEA2 '[^rp]error *\(' /dev/null \
475 | $(GREP) -E '"[A-Z]' \
476 | $(GREP) -vE '"FATAL|"WARNING|"Java|"C#|"PRI' \
477 && { echo '$(ME): found capitalized error message' 1>&2; \
478 exit 1; } \
479 || :
481 # Error messages should not end with a period
482 sc_error_message_period:
483 @$(VC_LIST_EXCEPT) \
484 | xargs $(GREP) -nEA2 '[^rp]error *\(' /dev/null \
485 | $(GREP) -E '[^."]\."' \
486 && { echo '$(ME): found error message ending in period' 1>&2; \
487 exit 1; } \
488 || :
490 sc_file_system:
491 @prohibit=file''system \
492 exclude='/proc/filesystems' \
493 ignore_case=1 \
494 halt='found use of "file''system"; spell it "file system"' \
495 $(_sc_search_regexp)
497 # Don't use cpp tests of this symbol. All code assumes config.h is included.
498 sc_prohibit_have_config_h:
499 @prohibit='^# *if.*HAVE''_CONFIG_H' \
500 halt='found use of HAVE''_CONFIG_H; remove' \
501 $(_sc_search_regexp)
503 # Nearly all .c files must include <config.h>. However, we also permit this
504 # via inclusion of a package-specific header, if cfg.mk specified one.
505 # config_h_header must be suitable for grep -E.
506 # Rationale: The Gnulib documentation, node 'Include <config.h>'.
507 config_h_header ?= <config\.h>
508 sc_require_config_h:
509 @require='^# *include $(config_h_header)' \
510 in_vc_files='\.c$$' \
511 halt='the above files do not include <config.h>' \
512 $(_sc_search_regexp)
514 # Print each file name for which the first #include does not match
515 # $(config_h_header). Like grep -m 1, this only looks at the first match.
516 perl_config_h_first_ = \
517 -e 'BEGIN {$$ret = 0}' \
518 -e 'if (/^\# *include\b/) {' \
519 -e ' if (not m{^\# *include $(config_h_header)}) {' \
520 -e ' print "$$ARGV\n";' \
521 -e ' $$ret = 1;' \
522 -e ' }' \
523 -e ' \# Move on to next file after first include' \
524 -e ' close ARGV;' \
525 -e '}' \
526 -e 'END {exit $$ret}'
528 # You must include <config.h> before including any other header file.
529 # This can possibly be via a package-specific header, if given by cfg.mk.
530 # Rationale: The Gnulib documentation, node 'Include <config.h>'.
531 sc_require_config_h_first:
532 @if $(VC_LIST_EXCEPT) | $(GREP) '\.c$$' > /dev/null; then \
533 files=$$($(VC_LIST_EXCEPT) | $(GREP) '\.c$$') && \
534 perl -n $(perl_config_h_first_) $$files || \
535 { echo '$(ME): the above files include some other header' \
536 'before <config.h>' 1>&2; exit 1; } || :; \
537 else :; \
540 # Generated headers that override system headers.
541 # Keep sorted.
542 gl_prefer_angle_bracket_headers_ ?= \
543 alloca.h \
544 arpa/inet.h \
545 assert.h \
546 ctype.h \
547 dirent.h \
548 errno.h \
549 error.h \
550 fcntl.h \
551 fenv.h \
552 float.h \
553 fnmatch.h \
554 getopt.h \
555 glob.h \
556 iconv.h \
557 inttypes.h \
558 langinfo.h \
559 limits.h \
560 locale.h \
561 malloc.h \
562 math.h \
563 monetary.h \
564 netdb.h \
565 net/if.h \
566 netinet/in.h \
567 omp.h \
568 poll.h \
569 pthread.h \
570 pty.h \
571 sched.h \
572 search.h \
573 selinux/selinux.h \
574 signal.h \
575 spawn.h \
576 stdalign.h \
577 stdarg.h \
578 stddef.h \
579 stdint.h \
580 stdio.h \
581 stdlib.h \
582 string.h \
583 strings.h \
584 sysexits.h \
585 sys/file.h \
586 sys/ioctl.h \
587 sys/msg.h \
588 sys/random.h \
589 sys/resource.h \
590 sys/select.h \
591 sys/sem.h \
592 sys/shm.h \
593 sys/socket.h \
594 sys/stat.h \
595 sys/time.h \
596 sys/times.h \
597 sys/types.h \
598 sys/uio.h \
599 sys/utsname.h \
600 sys/wait.h \
601 termios.h \
602 threads.h \
603 time.h \
604 uchar.h \
605 unistd.h \
606 utime.h \
607 utmp.h \
608 wchar.h \
609 wctype.h
611 # Remove each .h suffix and change each space to "|".
612 angle_bracket_header_re = \
613 $(subst $(_sp),|,$(patsubst %.h,%,$(gl_prefer_angle_bracket_headers_)))
615 # Suggest using '#include <header.h>' instead of '#include "header.h"' for
616 # headers that override system headers.
617 # Rationale: The Gnulib documentation, node 'Style of #include statements'.
618 sc_prefer_angle_bracket_headers:
619 @prohibit='^ *# *include "($(angle_bracket_header_re))\.h"' \
620 halt='Use #include <hdr.h>, not #include "hdr.h" for the above' \
621 $(_sc_search_regexp)
623 sc_prohibit_HAVE_MBRTOWC:
624 @prohibit='\bHAVE_MBRTOWC\b' \
625 halt="do not use $$prohibit; it is always defined" \
626 $(_sc_search_regexp)
628 # To use this "command" macro, you must first define two shell variables:
629 # h: the header name, with no enclosing <> or ""
630 # re: a regular expression that matches IFF something provided by $h is used.
631 define _sc_header_without_use
632 dummy=; : so we do not need a semicolon before each use; \
633 h_esc=`echo '[<"]'"$$h"'[">]'|$(SED) 's/\./\\\\./g'`; \
634 if $(VC_LIST_EXCEPT) | $(GREP) '\.c$$' > /dev/null; then \
635 files=$$($(GREP) -l '^# *include '"$$h_esc" \
636 $$($(VC_LIST_EXCEPT) | $(GREP) '\.c$$')) && \
637 $(GREP) -LE "$$re" $$files | $(GREP) . && \
638 { echo "$(ME): the above files include $$h but don't use it" \
639 1>&2; exit 1; } || :; \
640 else :; \
642 endef
644 # Prohibit the inclusion of assert.h without an actual use of assert.
645 sc_prohibit_assert_without_use:
646 @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
648 # Prohibit the inclusion of close-stream.h without an actual use.
649 sc_prohibit_close_stream_without_use:
650 @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
652 # Prohibit the inclusion of getopt.h without an actual use.
653 sc_prohibit_getopt_without_use:
654 @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
656 # Don't include quotearg.h unless you use one of its functions.
657 sc_prohibit_quotearg_without_use:
658 @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
660 # Don't include quote.h unless you use one of its functions.
661 sc_prohibit_quote_without_use:
662 @h='quote.h' re='\<quote((_n)? *\(|_quoting_options\>)' \
663 $(_sc_header_without_use)
665 # Don't include this header unless you use one of its functions.
666 sc_prohibit_long_options_without_use:
667 @h='long-options.h' re='\<parse_(long_options|gnu_standard_options_only) *\(' \
668 $(_sc_header_without_use)
670 # Don't include this header unless you use one of its functions.
671 sc_prohibit_inttostr_without_use:
672 @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
673 $(_sc_header_without_use)
675 # Don't include this header unless you use one of its functions.
676 sc_prohibit_ignore_value_without_use:
677 @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
678 $(_sc_header_without_use)
680 # Don't include this header unless you use one of its functions.
681 sc_prohibit_error_without_use:
682 @h='error.h' \
683 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
684 $(_sc_header_without_use)
686 # Don't include xalloc.h unless you use one of its symbols.
687 # Consider these symbols:
688 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
689 # perl -lne 'm{^(?:_Noreturn )?(?:void|char) \*?(\w+) *\(} and print $1' lib/xalloc.h
690 # Divide into two sets on case, and filter each through this:
691 # | sort | perl -MRegexp::Assemble -le \
692 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
693 _xa1 = x(i(m(emdup0?|alloc)|realloc(array)?|([cz]|nm)alloc)|([pz]|c(har)?|2n?re|nm)alloc|realloc(array)?|m(alloc|emdup)|alloc_die|strdup)
694 _xa2 = X([CZ]|N?M)ALLOC
695 sc_prohibit_xalloc_without_use:
696 @h='xalloc.h' \
697 re='\<($(_xa1)|$(_xa2)) *\('\
698 $(_sc_header_without_use)
700 # Extract function names:
701 # perl -lne '/^(?:extern )?(?:void|char|Hash_table) \*?(\w+) *\(/ and print $1' lib/hash.h
702 _hash_re = \
703 hash_(re(set_tuning|move)|xin(itialize|sert)|in(itialize|sert)|get_(firs|nex)t|print_statistics|(delet|fre)e|lookup|clear)
704 _hash_fn = \<($(_hash_re)) *\(
705 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
706 sc_prohibit_hash_without_use:
707 @h='hash.h' \
708 re='$(_hash_fn)|$(_hash_struct)'\
709 $(_sc_header_without_use)
711 sc_prohibit_cloexec_without_use:
712 @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
713 $(_sc_header_without_use)
715 sc_prohibit_posixver_without_use:
716 @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
718 sc_prohibit_same_without_use:
719 @h='same.h' re='\<same_name(at)? *\(' $(_sc_header_without_use)
721 sc_prohibit_hash_pjw_without_use:
722 @h='hash-pjw.h' \
723 re='\<hash_pjw\>' \
724 $(_sc_header_without_use)
726 sc_prohibit_safe_read_without_use:
727 @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
728 $(_sc_header_without_use)
730 sc_prohibit_argmatch_without_use:
731 @h='argmatch.h' \
732 re='(\<(ARGMATCH_DEFINE_GROUP|ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
733 $(_sc_header_without_use)
735 sc_prohibit_canonicalize_without_use:
736 @h='canonicalize.h' \
737 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
738 $(_sc_header_without_use)
740 sc_prohibit_root_dev_ino_without_use:
741 @h='root-dev-ino.h' \
742 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
743 $(_sc_header_without_use)
745 sc_prohibit_openat_without_use:
746 @h='openat.h' \
747 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat|(FCHMOD|FCHOWN|STAT)AT_INLINE)\>' \
748 $(_sc_header_without_use)
750 # Prohibit the inclusion of c-ctype.h without an actual use.
751 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
752 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
753 sc_prohibit_c_ctype_without_use:
754 @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
755 $(_sc_header_without_use)
757 # The following list was generated by running:
758 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
759 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
760 _sig_functions = \
761 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
762 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
763 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
764 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
765 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
766 # The following were extracted from "man signal.h" manually.
767 _sig_types_and_consts = \
768 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
769 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
770 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
771 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
772 sigstack sigval stack_t ucontext_t
773 # generated via this:
774 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
775 _sig_names = \
776 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
777 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
778 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
779 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
780 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
781 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
782 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
783 SIGXCPU SIGXFSZ
784 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
786 # Prohibit the inclusion of signal.h without an actual use.
787 sc_prohibit_signal_without_use:
788 @h='signal.h' \
789 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
790 $(_sc_header_without_use)
792 # Don't include stdio--.h unless you use one of its functions.
793 sc_prohibit_stdio--_without_use:
794 @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\(' \
795 $(_sc_header_without_use)
797 # Don't include stdio-safer.h unless you use one of its functions.
798 sc_prohibit_stdio-safer_without_use:
799 @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\(' \
800 $(_sc_header_without_use)
802 # Prohibit the inclusion of strings.h without a sensible use.
803 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
804 sc_prohibit_strings_without_use:
805 @h='strings.h' \
806 re='\<(strn?casecmp|ffs(ll)?)\>' \
807 $(_sc_header_without_use)
809 # Extract the raw list of symbol names with this:
810 gl_extract_define_simple = \
811 /^\# *define ([A-Z]\w+)\(/ and print $$1
812 # Filter out duplicates and convert to a space-separated list:
813 _intprops_names = \
814 $(shell f=$(gnulib_dir)/lib/intprops.h; \
815 perl -lne '$(gl_extract_define_simple)' $$f | sort -u | tr '\n' ' ')
816 # Remove trailing space and convert to a regular expression:
817 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
818 # Prohibit the inclusion of intprops.h without an actual use.
819 sc_prohibit_intprops_without_use:
820 @h='intprops.h' \
821 re='\<($(_intprops_syms_re)) *\(' \
822 $(_sc_header_without_use)
824 _stddef_syms_re = \
825 NULL|max_align_t|nullptr_t|offsetof|ptrdiff_t|size_t|unreachable|wchar_t
826 # Prohibit the inclusion of stddef.h without an actual use.
827 sc_prohibit_stddef_without_use:
828 @h='stddef.h' \
829 re='\<($(_stddef_syms_re))\>' \
830 $(_sc_header_without_use)
832 _de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
833 _de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
834 _de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
835 _dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
836 # Prohibit the inclusion of dirent.h without an actual use.
837 sc_prohibit_dirent_without_use:
838 @h='dirent.h' \
839 re='\<($(_dirent_syms_re))\>' \
840 $(_sc_header_without_use)
842 # Prohibit the inclusion of verify.h without an actual use.
843 sc_prohibit_verify_without_use:
844 @h='verify.h' \
845 re='\<(verify(_expr)?|assume) *\(' \
846 $(_sc_header_without_use)
848 # Don't include xfreopen.h unless you use one of its functions.
849 sc_prohibit_xfreopen_without_use:
850 @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
852 sc_obsolete_symbols:
853 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
854 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
855 $(_sc_search_regexp)
857 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
859 # Each nonempty ChangeLog line must start with a year number, or a TAB.
860 sc_changelog:
861 @prohibit='^[^12 ]' \
862 in_vc_files='^ChangeLog$$' \
863 halt='found unexpected prefix in a ChangeLog' \
864 $(_sc_search_regexp)
866 # Ensure that each .c file containing a "main" function also
867 # calls bindtextdomain.
868 sc_bindtextdomain:
869 @require='bindtextdomain *\(' \
870 in_vc_files='\.c$$' \
871 containing='\<main *(' \
872 halt='the above files do not call bindtextdomain' \
873 $(_sc_search_regexp)
875 # Require that the final line of each test-lib.sh-using test be this one:
876 # Exit $fail
877 # Note: this test requires GNU grep's --label= option.
878 Exit_witness_file ?= tests/test-lib.sh
879 Exit_base := $(notdir $(Exit_witness_file))
880 sc_require_test_exit_idiom:
881 @if test -f $(srcdir)/$(Exit_witness_file); then \
882 die=0; \
883 for i in $$($(GREP) -l -F 'srcdir/$(Exit_base)' \
884 $$($(VC_LIST) tests)); do \
885 tail -n1 $$i | $(GREP) '^Exit .' > /dev/null \
886 && : || { die=1; echo $$i; } \
887 done; \
888 test $$die = 1 && \
889 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
890 echo 1>&2 'Exit something'; \
891 exit 1; } || :; \
894 sc_trailing_blank:
895 @prohibit='[ ]$$' \
896 halt='found trailing blank(s)' \
897 exclude='^Binary file .* matches$$' \
898 $(_sc_search_regexp)
900 # Match lines like the following, but where there is only one space
901 # between the options and the description:
902 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
903 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*]?)?
904 sc_two_space_separator_in_usage:
905 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
906 halt='help2man requires at least two spaces between an option and its description'\
907 $(_sc_search_regexp)
909 # A regexp matching function names like "error" that may be used
910 # to emit translatable messages.
911 _gl_translatable_diag_func_re ?= error
913 # Look for diagnostics that aren't marked for translation.
914 # This won't find any for which error's format string is on a separate line.
915 sc_unmarked_diagnostics:
916 @prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
917 exclude='(_|ngettext ?)\(' \
918 halt='found unmarked diagnostic(s)' \
919 $(_sc_search_regexp)
921 # Avoid useless parentheses like those in this example:
922 # #if defined (SYMBOL) || defined (SYM2)
923 sc_useless_cpp_parens:
924 @prohibit='^# *if .*defined *\(' \
925 halt='found useless parentheses in cpp directive' \
926 $(_sc_search_regexp)
928 # List headers for which HAVE_HEADER_H is always true, assuming you are
929 # using the appropriate gnulib module. CAUTION: for each "unnecessary"
930 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
931 # requires the gnulib module that guarantees the usability of that header.
932 gl_assured_headers_ = \
933 cd $(gnulib_dir)/lib && echo *.in.h|$(SED) 's/\.in\.h//g'
935 # Convert the list of names to upper case, and replace each space with "|".
936 az_ = abcdefghijklmnopqrstuvwxyz
937 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
938 gl_header_upper_case_or_ = \
939 $$($(gl_assured_headers_) \
940 | tr $(az_)/.- $(AZ_)___ \
941 | tr -s ' ' '|' \
943 sc_prohibit_always_true_header_tests:
944 @or=$(gl_header_upper_case_or_); \
945 re="HAVE_($$or)_H"; \
946 prohibit='\<'"$$re"'\>' \
947 halt=$$(printf '%s\n' \
948 'do not test the above HAVE_<header>_H symbol(s);' \
949 ' with the corresponding gnulib module, they are always true') \
950 $(_sc_search_regexp)
952 sc_prohibit_defined_have_decl_tests:
953 @prohibit='(#[ ]*ifn?def|\<defined)\>[ (]+HAVE_DECL_' \
954 halt='HAVE_DECL macros are always defined' \
955 $(_sc_search_regexp)
957 # ==================================================================
958 gl_other_headers_ ?= \
959 intprops.h \
960 openat.h \
961 stat-macros.h
963 # Perl -lne code to extract "significant" cpp-defined symbols from a
964 # gnulib header file, eliminating a few common false-positives.
965 # The exempted names below are defined only conditionally in gnulib,
966 # and hence sometimes must/may be defined in application code.
967 gl_extract_significant_defines_ = \
968 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
969 && $$2 !~ /(?:rpl_|_used_without_)/\
970 && $$1 !~ /^(?:NSIG|ENODATA)$$/\
971 && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
972 and print $$1
974 # Create a list of regular expressions matching the names
975 # of macros that are guaranteed to be defined by parts of gnulib.
976 define def_sym_regex
977 gen_h=$(gl_generated_headers_); \
978 (cd $(gnulib_dir)/lib; \
979 for f in *.in.h $(gl_other_headers_); do \
980 test -f $$f \
981 && perl -lne '$(gl_extract_significant_defines_)' $$f; \
982 done; \
983 ) | sort -u \
984 | $(SED) 's/^/^ *# *(define|undef) */;s/$$/\\>/'
985 endef
987 # Don't define macros that we already get from gnulib header files.
988 sc_prohibit_always-defined_macros:
989 @if test -d $(gnulib_dir); then \
990 case $$(echo all: | $(GREP) -l -f - Makefile) in Makefile);; *) \
991 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
992 esac; \
993 regex=$$($(def_sym_regex)); export regex; \
994 $(VC_LIST_EXCEPT) \
995 | xargs sh -c 'echo $$regex | $(GREP) -E -f - "$$@"' \
996 dummy /dev/null \
997 && { printf '$(ME): define the above' \
998 ' via some gnulib .h file\n' 1>&2; \
999 exit 1; } \
1000 || :; \
1003 # ==================================================================
1005 # Prohibit checked in backup files.
1006 sc_prohibit_backup_files:
1007 @$(VC_LIST) | $(GREP) '~$$' && \
1008 { echo '$(ME): found version controlled backup file' 1>&2; \
1009 exit 1; } || :
1011 # Require the latest GPL.
1012 sc_GPL_version:
1013 @prohibit='either ''version [^3]' \
1014 halt='GPL vN, N!=3' \
1015 $(_sc_search_regexp)
1017 # Require the latest GFDL. Two regexp, since some .texi files end up
1018 # line wrapping between 'Free Documentation License,' and 'Version'.
1019 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
1020 sc_GFDL_version:
1021 @prohibit='$(_GFDL_regexp)' \
1022 halt='GFDL vN, N!=3' \
1023 $(_sc_search_regexp)
1025 # Don't use Texinfo's @acronym{}.
1026 # https://lists.gnu.org/r/bug-gnulib/2010-03/msg00321.html
1027 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
1028 sc_texinfo_acronym:
1029 @prohibit='@acronym\{' \
1030 in_vc_files='$(texinfo_suffix_re_)' \
1031 halt='found use of Texinfo @acronym{}' \
1032 $(_sc_search_regexp)
1034 cvs_keywords = \
1035 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
1037 sc_prohibit_cvs_keyword:
1038 @prohibit='\$$($(cvs_keywords))\$$' \
1039 halt='do not use CVS keyword expansion' \
1040 $(_sc_search_regexp)
1042 # This Perl code is slightly obfuscated. Not only is each "$" doubled
1043 # because it's in a Makefile, but the $$c's are comments; we cannot
1044 # use "#" due to the way the script ends up concatenated onto one line.
1045 # It would be much more concise, and would produce better output (including
1046 # counts) if written as:
1047 # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
1048 # but that would be far less efficient, reading the entire contents
1049 # of each file, rather than just the last two bytes of each.
1050 # In addition, while the code below detects both blank lines and a missing
1051 # newline at EOF, the above detects only the former.
1053 # This is a perl script that is expected to be the single-quoted argument
1054 # to a command-line "-le". The remaining arguments are file names.
1055 # Print the name of each file that does not end in exactly one newline byte.
1056 # I.e., warn if there are blank lines (2 or more newlines), or if the
1057 # last byte is not a newline. However, currently we don't complain
1058 # about any file that contains exactly one byte.
1059 # Exit nonzero if at least one such file is found, otherwise, exit 0.
1060 # Warn about, but otherwise ignore open failure. Ignore seek/read failure.
1062 # Use this if you want to remove trailing empty lines from selected files:
1063 # perl -pi -0777 -e 's/\n\n+$/\n/' files...
1065 require_exactly_one_NL_at_EOF_ = \
1066 foreach my $$f (@ARGV) \
1068 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
1069 my $$p = sysseek (F, -2, 2); \
1070 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
1071 my $$last_two_bytes; \
1072 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
1073 close F; \
1074 $$c = "ignore read failure"; \
1075 $$p && ($$last_two_bytes eq "\n\n" \
1076 || substr ($$last_two_bytes,1) ne "\n") \
1077 and (print $$f), $$fail=1; \
1079 END { exit defined $$fail }
1080 sc_prohibit_empty_lines_at_EOF:
1081 @$(VC_LIST_EXCEPT) \
1082 | xargs perl -le '$(require_exactly_one_NL_at_EOF_)' \
1083 || { echo '$(ME): empty line(s) or no newline at EOF' 1>&2; \
1084 exit 1; } \
1085 || :
1087 # Make sure we don't use st_blocks. Use ST_NBLOCKS or STP_NBLOCKS instead.
1088 # This is a bit of a kludge, since it prevents use of the string
1089 # even in comments, but for now it does the job with no false positives.
1090 sc_prohibit_stat_st_blocks:
1091 @prohibit='[.>]st_blocks' \
1092 halt='do not use st_blocks; use ST_NBLOCKS or STP_NBLOCKS' \
1093 $(_sc_search_regexp)
1095 # Make sure we don't define any S_IS* macros in src/*.c files.
1096 # They're already defined via gnulib's sys/stat.h replacement.
1097 sc_prohibit_S_IS_definition:
1098 @prohibit='^ *# *define *S_IS' \
1099 halt='do not define S_IS* macros; include <sys/stat.h>' \
1100 $(_sc_search_regexp)
1102 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
1103 # that is shared by two definitions below.
1104 perl_filename_lineno_text_ = \
1105 -e ' {' \
1106 -e ' $$n = ($$` =~ tr/\n/\n/ + 1);' \
1107 -e ' ($$v = $$&) =~ s/\n/\\n/g;' \
1108 -e ' print "$$ARGV:$$n:$$v\n";' \
1109 -e ' }'
1111 prohibit_doubled_words_ = \
1112 the then in an on if is it but for or at and do to can
1113 # expand the regex before running the check to avoid using expensive captures
1114 prohibit_doubled_word_expanded_ = \
1115 $(join $(prohibit_doubled_words_),$(addprefix \s+,$(prohibit_doubled_words_)))
1116 prohibit_doubled_word_RE_ ?= \
1117 /\b(?:$(subst $(_sp),|,$(prohibit_doubled_word_expanded_)))\b/gims
1118 prohibit_doubled_word_ = \
1119 -e 'while ($(prohibit_doubled_word_RE_))' \
1120 $(perl_filename_lineno_text_)
1122 # Define this to a regular expression that matches
1123 # any filename:dd:match lines you want to ignore.
1124 # The default is to ignore no matches.
1125 ignore_doubled_word_match_RE_ ?= ^$$
1127 sc_prohibit_doubled_word:
1128 @$(VC_LIST_EXCEPT) \
1129 | xargs perl -n -0777 $(prohibit_doubled_word_) \
1130 | $(GREP) -vE '$(ignore_doubled_word_match_RE_)' \
1131 | $(GREP) . \
1132 && { echo '$(ME): doubled words' 1>&2; exit 1; } \
1133 || :
1135 # A regular expression matching undesirable combinations of words like
1136 # "can not"; this matches them even when the two words appear on different
1137 # lines, but not when there is an intervening delimiter like "#" or "*".
1138 # Similarly undesirable, "See @xref{...}", since an @xref should start
1139 # a sentence. Explicitly prohibit any prefix of "see" or "also".
1140 # Also prohibit a prefix matching "\w+ +".
1141 # @pxref gets the same see/also treatment and should be parenthesized;
1142 # presume it must *not* start a sentence.
1143 # POSIX spells it "timestamp" rather than "time\s+stamp", so we do, too.
1144 bad_xref_re_ ?= (?:[\w,:;] +|(?:see|also)\s+)\@xref\{
1145 bad_pxref_re_ ?= (?:[.!?]|(?:see|also))\s+\@pxref\{
1146 prohibit_undesirable_word_seq_RE_ ?= \
1147 /(?:\bcan\s+not\b|\btime\s+stamps?\b|$(bad_xref_re_)|$(bad_pxref_re_))/gims
1148 prohibit_undesirable_word_seq_ = \
1149 -e 'while ($(prohibit_undesirable_word_seq_RE_))' \
1150 $(perl_filename_lineno_text_)
1151 # Define this to a regular expression that matches
1152 # any filename:dd:match lines you want to ignore.
1153 # The default is to ignore no matches.
1154 ignore_undesirable_word_sequence_RE_ ?= ^$$
1156 sc_prohibit_undesirable_word_seq:
1157 @$(VC_LIST_EXCEPT) \
1158 | xargs perl -n -0777 $(prohibit_undesirable_word_seq_) \
1159 | $(GREP) -vE '$(ignore_undesirable_word_sequence_RE_)' \
1160 | $(GREP) . \
1161 && { echo '$(ME): undesirable word sequence' >&2; exit 1; } \
1162 || :
1164 # Except for shell files and for loops, double semicolon is probably a mistake
1165 sc_prohibit_double_semicolon:
1166 @prohibit='; *;[ {} \]*(/[/*]|$$)' \
1167 in_vc_files='\.[chly]$$' \
1168 exclude='\bfor *\(.*\)' \
1169 halt="Double semicolon detected" \
1170 $(_sc_search_regexp)
1172 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
1173 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
1174 # Using test's -a and -o operators is not portable.
1175 # We prefer test over [, since the latter is spelled [[ in configure.ac.
1176 sc_prohibit_test_minus_ao:
1177 @prohibit='(\<test| \[+) .+ -[ao] ' \
1178 halt='$(_ptm1); $(_ptm2)' \
1179 $(_sc_search_regexp)
1181 # Avoid a test bashism.
1182 sc_prohibit_test_double_equal:
1183 @prohibit='(\<test| \[+) .+ == ' \
1184 containing='#! */bin/[a-z]*sh' \
1185 halt='use "test x = x", not "test x =''= x"' \
1186 $(_sc_search_regexp)
1188 # Each program that uses proper_name_utf8 must link with one of the
1189 # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
1190 # The perl -0777 invocation below extracts the possibly-multi-line
1191 # definition of LDADD from the appropriate Makefile.am and exits 0
1192 # when it contains "ICONV".
1193 sc_proper_name_utf8_requires_ICONV:
1194 @progs=$$($(VC_LIST_EXCEPT) \
1195 | xargs $(GREP) -l 'proper_name_utf8 ''("'); \
1196 if test "x$$progs" != x; then \
1197 fail=0; \
1198 for p in $$progs; do \
1199 dir=$$(dirname "$$p"); \
1200 perl -0777 \
1201 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
1202 $$dir/Makefile.am && continue; \
1203 base=$$(basename "$$p" .c); \
1204 $(GREP) "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
1205 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
1206 done; \
1207 test $$fail = 1 && \
1208 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
1209 exit 1; } || :; \
1212 # Warn about "c0nst struct Foo const foo[]",
1213 # but not about "char const *const foo" or "#define const const".
1214 sc_redundant_const:
1215 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
1216 halt='redundant "const" in declarations' \
1217 $(_sc_search_regexp)
1219 sc_const_long_option:
1220 @prohibit='^ *static.*struct option ' \
1221 exclude='const struct option|struct option const' \
1222 halt='add "const" to the above declarations' \
1223 $(_sc_search_regexp)
1225 NEWS_hash = \
1226 $$($(SED) -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
1227 $(srcdir)/NEWS \
1228 | perl -0777 -pe \
1229 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
1230 | md5sum - \
1231 | $(SED) 's/ .*//')
1233 # Ensure that we don't accidentally insert an entry into an old NEWS block.
1234 sc_immutable_NEWS:
1235 @if test -f $(srcdir)/NEWS; then \
1236 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
1237 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
1240 # Update the hash stored above. Do this after each release and
1241 # for any corrections to old entries.
1242 update-NEWS-hash: NEWS
1243 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1244 $(srcdir)/cfg.mk
1246 # Ensure that we use only the standard $(VAR) notation,
1247 # not @...@ in Makefile.am, now that we can rely on automake
1248 # to emit a definition for each substituted variable.
1249 # However, there is still one case in which @VAR@ use is not just
1250 # legitimate, but actually required: when augmenting an automake-defined
1251 # variable with a prefix. For example, gettext uses this:
1252 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1253 # otherwise, makeinfo would put German or French (current locale)
1254 # navigation hints in the otherwise-English documentation.
1256 # Allow the package to add exceptions via a hook in cfg.mk;
1257 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1258 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1259 _makefile_at_at_check_exceptions ?=
1260 sc_makefile_at_at_check:
1261 @perl -ne '/\@\w+\@/' \
1262 -e ' && !/(\w+)\s+=.*\@\1\@$$/' \
1263 -e ''$(_makefile_at_at_check_exceptions) \
1264 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
1265 $$($(VC_LIST_EXCEPT) | $(GREP) -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1266 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1268 news-check: NEWS
1269 $(AM_V_GEN)if $(SED) -n $(news-check-lines-spec)p $< \
1270 | $(GREP) -E $(news-check-regexp) >/dev/null; then \
1271 :; \
1272 else \
1273 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
1274 exit 1; \
1277 sc_makefile_TAB_only_indentation:
1278 @prohibit='^ [ ]{8}' \
1279 in_vc_files='akefile|\.mk$$' \
1280 halt='found TAB-8-space indentation' \
1281 $(_sc_search_regexp)
1283 sc_m4_quote_check:
1284 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
1285 in_vc_files='(^configure\.ac|\.m4)$$' \
1286 halt='quote the first arg to AC_DEF*' \
1287 $(_sc_search_regexp)
1289 fix_po_file_diag = \
1290 'you have changed the set of files with translatable diagnostics;\n\
1291 apply the above patch\n'
1293 # Generate a list of files in which to search for translatable strings.
1294 perl_translatable_files_list_ = \
1295 -e 'foreach $$file (@ARGV) {' \
1296 -e ' \# Consider only file extensions with one or two letters' \
1297 -e ' $$file =~ /\...?$$/ or next;' \
1298 -e ' \# Ignore m4 and mk files' \
1299 -e ' $$file =~ /\.m[4k]$$/ and next;' \
1300 -e ' \# Ignore a .c or .h file with a corresponding .l or .y file' \
1301 -e ' $$file =~ /(.+)\.[ch]$$/ && (-e "$${1}.l" || -e "$${1}.y")' \
1302 -e ' and next;' \
1303 -e ' \# Skip unreadable files' \
1304 -e ' -r $$file or next;' \
1305 -e ' print "$$file ";' \
1306 -e '}'
1308 # Verify that all source files using _() (more specifically, files that
1309 # match $(_gl_translatable_string_re)) are listed in po/POTFILES.in.
1310 po_file ?= $(srcdir)/po/POTFILES.in
1311 generated_files ?= $(srcdir)/lib/*.[ch]
1312 _gl_translatable_string_re ?= \b(N?_|gettext *)\([^)"]*("|$$)
1313 sc_po_check:
1314 @if test -f $(po_file); then \
1315 $(GREP) -E -v '^(#|$$)' $(po_file) \
1316 | $(GREP) -v '^src/false\.c$$' | sort > $@-1; \
1317 { $(VC_LIST_EXCEPT); echo $(generated_files); } \
1318 | xargs perl $(perl_translatable_files_list_) \
1319 | xargs $(GREP) -E -l '$(_gl_translatable_string_re)' \
1320 | $(SED) 's|^$(_dot_escaped_srcdir)/||' \
1321 | sort -u > $@-2; \
1322 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
1323 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
1324 rm -f $@-1 $@-2; \
1327 # Sometimes it is useful to change the PATH environment variable
1328 # in Makefiles. When doing so, it's better not to use the Unix-centric
1329 # path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
1330 msg = 'Do not use ":" above; use $$(PATH_SEPARATOR) instead'
1331 sc_makefile_path_separator_check:
1332 @prohibit='PATH[=].*:' \
1333 in_vc_files='akefile|\.mk$$' \
1334 halt=$(msg) \
1335 $(_sc_search_regexp)
1337 sc_makefile_DISTCHECK_CONFIGURE_FLAGS:
1338 @prohibit='^DISTCHECK_CONFIGURE_FLAGS' \
1339 in_vc_files='akefile|\.mk$$' \
1340 halt="use AM_DISTCHECK_CONFIGURE_FLAGS" \
1341 $(_sc_search_regexp)
1343 # Check that 'make alpha' will not fail at the end of the process,
1344 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1345 # and is read-only.
1346 writable-files:
1347 $(AM_V_GEN)if test -d $(release_archive_dir); then \
1348 for file in $(DIST_ARCHIVES); do \
1349 for p in ./ $(release_archive_dir)/; do \
1350 test -e $$p$$file || continue; \
1351 test -w $$p$$file \
1352 || { echo ERROR: $$p$$file is not writable; fail=1; }; \
1353 done; \
1354 done; \
1355 test "$$fail" && exit 1 || : ; \
1356 else :; \
1359 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1360 sample-test = tests/sample-test
1361 texi = doc/$(PACKAGE).texi
1362 # Make sure that the copyright date in $(v_etc_file) is up to date.
1363 # Do the same for the $(sample-test) and the main doc/.texi file.
1364 sc_copyright_check:
1365 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
1366 in_files=$(v_etc_file) \
1367 halt='out of date copyright in $(v_etc_file); update it' \
1368 $(_sc_search_regexp)
1369 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
1370 in_vc_files=$(sample-test) \
1371 halt='out of date copyright in $(sample-test); update it' \
1372 $(_sc_search_regexp)
1373 @require='Copyright @copyright\{} .*'$$(date +%Y) \
1374 in_vc_files=$(texi) \
1375 halt='out of date copyright in $(texi); update it' \
1376 $(_sc_search_regexp)
1378 # If tests/help-version exists and seems to be new enough, assume that its
1379 # use of init.sh and path_prepend_ is correct, and ensure that every other
1380 # use of init.sh is identical.
1381 # This is useful because help-version cross-checks prog --version
1382 # with $(VERSION), which verifies that its path_prepend_ invocation
1383 # sets PATH correctly. This is an inexpensive way to ensure that
1384 # the other init.sh-using tests also get it right.
1385 _hv_file ?= $(srcdir)/tests/help-version
1386 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1387 # Fix syntax-highlighters "
1388 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1389 sc_cross_check_PATH_usage_in_tests:
1390 @if test -f $(_hv_file); then \
1391 $(GREP) -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1392 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1393 exit 0; }; \
1394 $(GREP) -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1395 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1396 exit 1; }; \
1397 good=$$($(GREP) -E '$(_hv_regex_strong)' $(_hv_file)); \
1398 $(VC_LIST_EXCEPT) \
1399 | xargs $(GREP) -lE '$(_hv_regex_weak)' \
1400 | xargs $(GREP) -LFx "$$good" \
1401 | $(GREP) . \
1402 && { printf "$(ME): the above files use" \
1403 " path_prepend_ inconsistently\n" 1>&2; \
1404 exit 1; } \
1405 || :; \
1408 # BRE regex of file contents to identify a test script.
1409 _test_script_regex ?= \<init\.sh\>
1411 # In tests, use "compare expected actual", not the reverse.
1412 sc_prohibit_reversed_compare_failure:
1413 @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)' \
1414 containing='$(_test_script_regex)' \
1415 halt='reversed compare arguments' \
1416 $(_sc_search_regexp)
1418 # #if HAVE_... will evaluate to false for any non numeric string.
1419 # That would be flagged by using -Wundef, however gnulib currently
1420 # tests many undefined macros, and so we can't enable that option.
1421 # So at least preclude common boolean strings as macro values.
1422 sc_Wundef_boolean:
1423 @prohibit='^#define.*(yes|no|true|false)$$' \
1424 in_files='$(CONFIG_INCLUDE)' \
1425 halt='Use 0 or 1 for macro values' \
1426 $(_sc_search_regexp)
1428 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1429 # not be constant, or might overflow a stack. In general, use PATH_MAX as
1430 # a limit, not an array or alloca size.
1431 sc_prohibit_path_max_allocation:
1432 @prohibit='(\balloca *\([^)]*|\[[^]]*)\bPATH_MAX' \
1433 halt='Avoid stack allocations of size PATH_MAX' \
1434 $(_sc_search_regexp)
1436 sc_vulnerable_makefile_CVE-2009-4029:
1437 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1438 in_files='(^|/)Makefile\.in$$' \
1439 halt=$$(printf '%s\n' \
1440 'the above files are vulnerable; beware of running' \
1441 ' "make dist*" rules, and upgrade to fixed automake' \
1442 ' see https://bugzilla.redhat.com/show_bug.cgi?id=542609 for details') \
1443 $(_sc_search_regexp)
1445 sc_vulnerable_makefile_CVE-2012-3386:
1446 @prohibit='chmod a\+w \$$\(distdir\)' \
1447 in_files='(^|/)Makefile\.in$$' \
1448 halt=$$(printf '%s\n' \
1449 'the above files are vulnerable; beware of running' \
1450 ' "make distcheck", and upgrade to fixed automake' \
1451 ' see https://bugzilla.redhat.com/show_bug.cgi?id=CVE-2012-3386 for details') \
1452 $(_sc_search_regexp)
1454 sc_unportable_grep_q:
1455 @prohibit='grep -q' halt="unportable 'grep -q', use >/dev/null instead" \
1456 $(_sc_search_regexp)
1458 # The GNU Coding standards say that README should refer to both
1459 # INSTALL and the file that contains the copying conditions. This
1460 # shall be COPYING for GPL and COPYING.LESSER for LGPL.
1462 sc_readme_link_install:
1463 @require='INSTALL' \
1464 in_vc_files='^README$$' \
1465 halt='The README file should refer to INSTALL' \
1466 $(_sc_search_regexp)
1468 sc_readme_link_copying:
1469 @require='COPYING' \
1470 in_vc_files='^README$$' \
1471 halt='The README file should refer to COPYING[.LESSER]' \
1472 $(_sc_search_regexp)
1474 vc-diff-check:
1475 $(AM_V_GEN)(unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1476 $(AM_V_at)if test -s vc-diffs; then \
1477 cat vc-diffs; \
1478 echo "Some files are locally modified:" 1>&2; \
1479 exit 1; \
1480 else \
1481 rm vc-diffs; \
1484 rel-files = $(DIST_ARCHIVES)
1486 gnulib-version = $$(cd $(gnulib_dir) \
1487 && { git describe || git rev-parse --short=10 HEAD; } )
1488 bootstrap-tools ?= autoconf,automake,gnulib
1490 gpgv = $$(gpgv2 --version >/dev/null && echo gpgv2 || echo gpgv)
1491 # If it's not already specified, derive the GPG key ID from
1492 # the signed tag we've just applied to mark this release.
1493 gpg_key_ID ?= \
1494 $$(cd $(srcdir) \
1495 && git cat-file tag v$(VERSION) \
1496 | $(gpgv) --status-fd 1 --keyring /dev/null - - 2>/dev/null \
1497 | $(AWK) '/^\[GNUPG:] ERRSIG / {print $$3; exit}')
1498 gpg_key_email ?= \
1499 $$(gpg --list-key --with-colons $(gpg_key_ID) 2>/dev/null \
1500 | $(AWK) -F: '/^uid/ {print $$10; exit}' \
1501 | $(SED) -n 's/.*<\(.*\)>/\1/p')
1502 gpg_keyring_url ?= https://savannah.gnu.org/project/release-gpgkeys.php?group=$(PACKAGE)&download=1
1504 translation_project_ ?= coordinator@translationproject.org
1506 # Make info-gnu the default only for a stable release.
1507 announcement_Cc_stable = $(translation_project_), $(PACKAGE_BUGREPORT)
1508 announcement_mail_headers_stable = \
1509 To: info-gnu@gnu.org \
1510 Cc: $(announcement_Cc_) \
1511 Mail-Followup-To: $(PACKAGE_BUGREPORT)
1513 announcement_Cc_alpha = $(translation_project_)
1514 announcement_mail_headers_alpha = \
1515 To: $(PACKAGE_BUGREPORT) \
1516 Cc: $(announcement_Cc_)
1518 announcement_mail_Cc_beta = $(announcement_mail_Cc_alpha)
1519 announcement_mail_headers_beta = $(announcement_mail_headers_alpha)
1521 announcement_Cc_ ?= $(announcement_Cc_$(release-type))
1522 announcement_mail_headers_ ?= $(announcement_mail_headers_$(release-type))
1523 announcement: NEWS ChangeLog $(rel-files)
1524 # Not $(AM_V_GEN) since the output of this command serves as
1525 # announcement message: it would start with " GEN announcement".
1526 $(AM_V_at)$(srcdir)/$(_build-aux)/announce-gen \
1527 --mail-headers='$(announcement_mail_headers_)' \
1528 --release-type=$(release-type) \
1529 --package=$(PACKAGE) \
1530 --prev=$(PREV_VERSION) \
1531 --curr=$(VERSION) \
1532 --gpg-key-id=$(gpg_key_ID) \
1533 $$(test -n "$(gpg_key_email)" && \
1534 echo --gpg-key-email="$(gpg_key_email)") \
1535 $$(test -n "$(gpg_keyring_url)" && \
1536 echo --gpg-keyring-url="$(gpg_keyring_url)") \
1537 --srcdir=$(srcdir) \
1538 --news=$(srcdir)/NEWS \
1539 --bootstrap-tools=$(bootstrap-tools) \
1540 $$(case ,$(bootstrap-tools), in (*,gnulib,*) \
1541 echo --gnulib-version=$(gnulib-version);; esac) \
1542 $(addprefix --url-dir=, $(url_dir_list))
1544 .PHONY: release-commit
1545 release-commit:
1546 $(AM_V_GEN)cd $(srcdir) \
1547 && $(_build-aux)/do-release-commit-and-tag \
1548 -C $(abs_builddir) $(RELEASE)
1550 ## ---------------- ##
1551 ## Updating files. ##
1552 ## ---------------- ##
1554 ftp-gnu = https://ftp.gnu.org/gnu
1555 www-gnu = https://www.gnu.org
1557 upload_dest_dir_ ?= $(PACKAGE)
1558 upload_command = \
1559 $(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \
1560 --to $(gnu_rel_host):$(upload_dest_dir_) \
1561 $(rel-files)
1562 emit_upload_commands:
1563 @echo =====================================
1564 @echo =====================================
1565 @echo '$(upload_command)'
1566 @echo '# send the ~/announce-$(my_distdir) e-mail'
1567 @echo =====================================
1568 @echo =====================================
1570 .PHONY: upload
1571 upload:
1572 $(AM_V_GEN)$(upload_command)
1574 define emit-commit-log
1575 printf '%s\n' 'maint: post-release administrivia' '' \
1576 '* NEWS: Add header line for next release.' \
1577 '* .prev-version: Record previous version.' \
1578 '* cfg.mk (old_NEWS_hash): Auto-update.'
1579 endef
1581 .PHONY: no-submodule-changes
1582 no-submodule-changes:
1583 $(AM_V_GEN)if test -d $(srcdir)/.git \
1584 && git --version >/dev/null 2>&1; then \
1585 diff=$$(cd $(srcdir) && git submodule -q foreach \
1586 git diff-index --name-only HEAD) \
1587 || exit 1; \
1588 case $$diff in '') ;; \
1589 *) echo '$(ME): submodule files are locally modified:'; \
1590 echo "$$diff"; exit 1;; esac; \
1591 else \
1592 : ; \
1595 submodule-checks ?= no-submodule-changes public-submodule-commit
1597 # Ensure that each sub-module commit we're using is public.
1598 # Without this, it is too easy to tag and release code that
1599 # cannot be built from a fresh clone.
1600 .PHONY: public-submodule-commit
1601 public-submodule-commit:
1602 $(AM_V_GEN)if test -d $(srcdir)/.git \
1603 && git --version >/dev/null 2>&1; then \
1604 cd $(srcdir) && \
1605 git submodule --quiet foreach \
1606 'test "$$(git rev-parse "$$sha1")" \
1607 = "$$(git merge-base origin "$$sha1")"' \
1608 || { echo '$(ME): found non-public submodule commit' >&2; \
1609 exit 1; }; \
1610 else \
1611 : ; \
1613 # This rule has a high enough utility/cost ratio that it should be a
1614 # dependent of "check" by default. However, some of us do occasionally
1615 # commit a temporary change that deliberately points to a non-public
1616 # submodule commit, and want to be able to use rules like "make check".
1617 # In that case, run e.g., "make check gl_public_submodule_commit="
1618 # to disable this test.
1619 gl_public_submodule_commit ?= public-submodule-commit
1620 check: $(gl_public_submodule_commit)
1622 .PHONY: alpha beta stable release
1623 ALL_RECURSIVE_TARGETS += alpha beta stable
1624 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1625 $(AM_V_GEN)test $@ = stable \
1626 && { echo $(VERSION) | $(GREP) -E '^[0-9]+(\.[0-9]+)+$$' \
1627 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1628 || :
1629 $(AM_V_at)$(MAKE) vc-diff-check
1630 $(AM_V_at)$(MAKE) news-check
1631 $(AM_V_at)$(MAKE) distcheck
1632 $(AM_V_at)$(MAKE) dist
1633 $(AM_V_at)$(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1634 $(AM_V_at)$(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1636 release:
1637 $(AM_V_GEN)$(MAKE) _version
1638 $(AM_V_at)$(MAKE) $(release-type)
1640 # Override this in cfg.mk if you follow different procedures.
1641 release-prep-hook ?= release-prep
1643 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1644 .PHONY: release-prep
1645 release-prep:
1646 $(AM_V_GEN)$(MAKE) --no-print-directory -s announcement \
1647 > ~/announce-$(my_distdir)
1648 $(AM_V_at)if test -d $(release_archive_dir); then \
1649 ln $(rel-files) $(release_archive_dir); \
1650 chmod a-w $(rel-files); \
1652 $(AM_V_at)echo $(VERSION) > $(prev_version_file)
1653 $(AM_V_at)$(MAKE) update-NEWS-hash
1654 $(AM_V_at)perl -pi \
1655 -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' \
1656 $(srcdir)/NEWS
1657 $(AM_V_at)msg=$$($(emit-commit-log)) || exit 1; \
1658 cd $(srcdir) && $(VC) commit -m "$$msg" -a
1660 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1661 # if the default $(PACKAGE)-derived name doesn't apply.
1662 gendocs_options_ ?=
1664 .PHONY: web-manual
1665 web-manual:
1666 $(AM_V_GEN)test -z "$(manual_title)" \
1667 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1668 $(AM_V_at)cd '$(srcdir)/doc'; \
1669 $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
1670 -o '$(abs_builddir)/doc/manual' \
1671 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1672 "$(PACKAGE_NAME) - $(manual_title)"
1673 $(AM_V_at)echo " *** Upload the doc/manual directory to web-cvs."
1675 .PHONY: web-manual-update
1676 web-manual-update:
1677 $(AM_V_GEN)cd $(srcdir) \
1678 && $(_build-aux)/gnu-web-doc-update -C $(abs_builddir)
1681 # Code Coverage
1683 init-coverage:
1684 $(MAKE) $(AM_MAKEFLAGS) clean
1685 lcov --directory . --zerocounters
1687 COVERAGE_CCOPTS ?= "-g --coverage"
1688 COVERAGE_OUT ?= doc/coverage
1690 build-coverage:
1691 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1692 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1693 mkdir -p $(COVERAGE_OUT)
1694 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1695 --capture
1697 gen-coverage:
1698 genhtml --output-directory $(COVERAGE_OUT) \
1699 $(COVERAGE_OUT)/$(PACKAGE).info \
1700 --highlight --frames --legend \
1701 --title "$(PACKAGE_NAME)"
1703 coverage:
1704 $(MAKE) init-coverage
1705 $(MAKE) build-coverage
1706 $(MAKE) gen-coverage
1708 # Some projects carry local adjustments for gnulib modules via patches in
1709 # a gnulib patch directory whose default name is gl/ (defined in bootstrap
1710 # via local_gl_dir=gl). Those patches become stale as the originals evolve
1711 # in gnulib. Use this rule to refresh any stale patches. It applies each
1712 # patch to the original in $(gnulib_dir) and uses the temporary result to
1713 # generate a fuzz-free .diff file. If you customize the name of your local
1714 # gnulib patch directory via bootstrap.conf, this rule detects that name.
1715 # Run this from a non-VPATH (i.e., srcdir) build directory.
1716 .PHONY: refresh-gnulib-patches
1717 refresh-gnulib-patches:
1718 gl=gl; \
1719 if test -f bootstrap.conf; then \
1720 t=$$(perl -lne '/^\s*local_gl_dir=(\S+)/ and $$d=$$1;' \
1721 -e 'END{defined $$d and print $$d}' bootstrap.conf); \
1722 test -n "$$t" && gl=$$t; \
1723 fi; \
1724 for diff in $$(cd $$gl; git ls-files | $(GREP) '\.diff$$'); do \
1725 b=$$(printf %s "$$diff"|$(SED) 's/\.diff$$//'); \
1726 VERSION_CONTROL=none \
1727 patch "$(gnulib_dir)/$$b" "$$gl/$$diff" || exit 1; \
1728 ( cd $(gnulib_dir) || exit 1; \
1729 git diff "$$b" > "../$$gl/$$diff"; \
1730 git checkout $$b ) || exit 1; \
1731 done
1733 # Update gettext files.
1734 PACKAGE ?= $(shell basename $(PWD))
1735 PO_DOMAIN ?= $(PACKAGE)
1736 POURL = https://translationproject.org/latest/$(PO_DOMAIN)/
1737 PODIR ?= po
1738 refresh-po:
1739 rm -f $(PODIR)/*.po && \
1740 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1741 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1742 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1743 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1744 ls $(PODIR)/*.po | $(SED) 's/\.po//;s,$(PODIR)/,,' | \
1745 sort >> $(PODIR)/LINGUAS
1747 # Indentation
1749 indent_args ?= -ppi 1
1750 C_SOURCES ?= $$($(VC_LIST_EXCEPT) | grep '\.[ch]\(.in\)\?$$')
1751 INDENT_SOURCES ?= $(C_SOURCES)
1752 exclude_file_name_regexp--indent ?= $(exclude_file_name_regexp--sc_indent)
1754 .PHONY: indent
1755 indent: # Running indent once is not idempotent, but running it twice is.
1756 $(AM_V_GEN)indent $(indent_args) $(INDENT_SOURCES) && \
1757 indent $(indent_args) $(INDENT_SOURCES)
1759 sc_indent:
1760 @if ! indent --version 2> /dev/null | grep 'GNU indent' > /dev/null; then \
1761 echo 1>&2 '$(ME): sc_indent: GNU indent is missing'; \
1762 else \
1763 fail=0; files="$(INDENT_SOURCES)"; \
1764 for f in $$files; do \
1765 indent $(indent_args) -st $$f \
1766 | indent $(indent_args) -st - \
1767 | diff -u $$f - || fail=1; \
1768 done; \
1769 test $$fail = 1 && \
1770 { echo 1>&2 '$(ME): code format error, try "make indent"'; \
1771 exit 1; } || :; \
1774 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1775 # put the assignments in this variable.
1776 update-copyright-env ?=
1778 # Run this rule once per year (usually early in January)
1779 # to update all FSF copyright year lists in your project.
1780 # If you have an additional project-specific rule,
1781 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1782 # By default, exclude all variants of COPYING; you can also
1783 # add exemptions (such as ChangeLog..* for rotated change logs)
1784 # in the file .x-update-copyright.
1785 .PHONY: update-copyright
1786 update-copyright:
1787 $(AM_V_GEN)$(GREP) -l -w Copyright \
1788 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1789 | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
1791 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1792 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1794 # NOTE: to override any _gl_TS_* default value, you must
1795 # define the variable(s) using "export" in cfg.mk.
1796 _gl_TS_dir ?= src
1798 ALL_RECURSIVE_TARGETS += sc_tight_scope
1799 sc_tight_scope: tight-scope.mk
1800 @fail=0; \
1801 if ! $(GREP) '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk \
1802 > /dev/null \
1803 && ! $(GREP) -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1804 > /dev/null 2>&1; then \
1805 echo '$(ME): skipping $@'; \
1806 else \
1807 $(MAKE) -s -C $(_gl_TS_dir) \
1808 -f Makefile \
1809 -f $(abs_top_srcdir)/cfg.mk \
1810 -f $(abs_top_builddir)/$< \
1811 _gl_tight_scope \
1812 || fail=1; \
1813 fi; \
1814 rm -f $<; \
1815 exit $$fail
1817 tight-scope.mk: $(ME)
1818 @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
1819 @mv $@-t $@
1821 ifeq (a,b)
1822 # TS-start
1824 # Most functions should have static scope.
1825 # Any that don't must be marked with 'extern', but 'main'
1826 # and 'usage' are exceptions: they're always extern, but
1827 # do not need to be marked. Symbols matching '__.*' are
1828 # reserved by the compiler, so are automatically excluded below.
1829 _gl_TS_unmarked_extern_functions ?= main usage
1830 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\w+) *\(/
1832 # If your project uses a macro like "XTERN", then put
1833 # the following in cfg.mk to override this default:
1834 # export _gl_TS_extern = extern|XTERN
1835 _gl_TS_extern ?= extern
1837 # The second nm|grep checks for file-scope variables with 'extern' scope.
1838 # Without gnulib's progname module, you might put program_name here.
1839 # Symbols matching '__.*' are reserved by the compiler,
1840 # so are automatically excluded below.
1841 _gl_TS_unmarked_extern_vars ?=
1843 # NOTE: the _match variables are perl expressions -- not mere regular
1844 # expressions -- so that you can extend them to match other patterns
1845 # and easily extract matched variable names.
1846 # For example, if your project declares some global variables via
1847 # a macro like this: GLOBAL(type, var_name, initializer), then you
1848 # can override this definition to automatically extract those names:
1849 # export _gl_TS_var_match = \
1850 # /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1851 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?])?;/
1853 # The names of object files in (or relative to) $(_gl_TS_dir).
1854 _gl_TS_obj_files ?= *.$(OBJEXT)
1856 # Files in which to search for the one-line style extern declarations.
1857 # $(_gl_TS_dir)-relative.
1858 _gl_TS_headers ?= $(noinst_HEADERS)
1859 _gl_TS_other_headers ?= *.h
1861 .PHONY: _gl_tight_scope
1862 _gl_tight_scope: $(bin_PROGRAMS)
1863 sed_wrap='s/^/^_?/;s/$$/$$/'; \
1864 t=exceptions-$$$$; \
1865 trap 's=$$?; rm -f $$t; exit $$s' 0; \
1866 for sig in 1 2 3 13 15; do \
1867 eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1868 done; \
1869 src=`for f in $(SOURCES); do \
1870 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1871 hdr=`for f in $(_gl_TS_headers); do \
1872 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1873 ( printf '%s\n' '__.*' $(_gl_TS_unmarked_extern_functions); \
1874 $(GREP) -h -A1 '^extern .*[^;]$$' $$src \
1875 | $(GREP) -vE '^(extern |--|#)' | $(SED) 's/ .*//; /^$$/d'; \
1876 perl -lne \
1877 '$(_gl_TS_function_match) and print $$1' $$hdr; \
1878 ) | sort -u | $(SED) "$$sed_wrap" > $$t; \
1879 nm -g $(_gl_TS_obj_files)|$(SED) -n 's/.* T //p'|$(GREP) -Ev -f $$t \
1880 && { echo the above functions should have static scope >&2; \
1881 exit 1; } || : ; \
1882 ( printf '%s\n' '__.*' main $(_gl_TS_unmarked_extern_vars); \
1883 perl -lne '$(_gl_TS_var_match) and print $$1' \
1884 $$hdr $(_gl_TS_other_headers) \
1885 ) | sort -u | $(SED) "$$sed_wrap" > $$t; \
1886 nm -g $(_gl_TS_obj_files) | $(SED) -n 's/.* [BCDGRS] //p' \
1887 | sort -u | $(GREP) -Ev -f $$t \
1888 && { echo the above variables should have static scope >&2; \
1889 exit 1; } || :
1890 # TS-end
1891 endif